//Lightning.cs
//By Amad (ID 10716)
//Requested by Dunken for some sort of RPG project

//Thanks to ClickTeam for their very nice sound resources
// *** http://www.clickteam.com/ *** //
datablock AudioProfile(LightningZapSound)
{
   filename    = "./LightningZapSound.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(LightningLoopSound)
{
   filename    = "./LightningLoopSound.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock ParticleData(LightningAmbientParticle)
{
	dragCoefficient			= 3;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.75;
	constantAcceleration	= 0;
	lifetimeMS			= 250;
	lifetimeVarianceMS	= 50;
	textureName			= "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed			= 10;
	spinRandomMin		= -300;
	spinRandomMax		= 290;
	colors[0]	= "0 1 1 1";
	colors[1]	= "0 1 1 0";
	sizes[0]	= 0.25;
	sizes[1]	= 1.1;
};
datablock ParticleEmitterData(LightningAmbientEmitter)
{
   ejectionPeriodMS	= 30;
   periodVarianceMS	= 0;
   ejectionVelocity	= 1.0;
   velocityVariance	= 1.0;
   ejectionOffset	= 0.0;
   thetaMin			= 0;
   thetaMax			= 90;
   phiReferenceVel	= 0;
   phiVariance		= 360;
   overrideAdvance	= false;
   particles		= "LightningAmbientParticle";

   uiName = "Lightning Ambient";
};

datablock ParticleData(LightningTrailParticle)
{
	dragCoefficient			= 5;
	gravityCoefficient		= 0;
	inheritedVelFactor		= 0.15;
	constantAcceleration	= 0;
	lifetimeMS			= 1000;
	lifetimeVarianceMS	= 500;
	textureName			= "Add-Ons/Projectile_Radio_Wave/bolt";
	spinSpeed			= 10;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0 1 1 1";
	colors[1]	= "0 0.5 1 0";
	sizes[0]	= 1;
	sizes[1]	= 0;
};
datablock ParticleEmitterData(LightningTrailEmitter)
{
   ejectionPeriodMS	= 5;
   periodVarianceMS	= 0;
   ejectionVelocity	= 2;
   velocityVariance	= 1.5;
   ejectionOffset	= 0.2;
   thetaMin			= 115;
   thetaMax			= 175;
   phiReferenceVel	= 0;
   phiVariance		= 360;
   overrideAdvance	= false;
   particles		= "LightningTrailParticle";

   uiName = "Lightning Trail";
};

datablock ExplosionData(LightningExplosion)
{
   soundProfile = LightningZapSound;

   lifeTimeMS = 250;

   particleEmitter = LightningTrailEmitter;
   particleDensity = 150;
   particleRadius = 2.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "30 30 30";
   camShakeAmp = "7 2 7";
   camShakeDuration = 0.6;
   camShakeRadius = 2.5;

   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 1";

   damageRadius = 2.5;
   radiusDamage = 50;

   uiName = "Lightning Zap";
};

AddDamageType("Lightning",
'<bitmap:add-ons/Weapon_Lightning/CI_Lightning> %1', //Suicide message
'%2 <bitmap:add-ons/Weapon_Lightning/CI_Lightning> %1',0.2,1); //Kill message

datablock ProjectileData(LightningBolt)
{
   sound = "LightningLoopSound";
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 5; //Most of the damage comes from the radius
   directDamageType    = $DamageType::Lightning;
   radiusDamageType    = $DamageType::Lightning;

   brickExplosionRadius		= 4;
   brickExplosionImpact		= true;
   brickExplosionForce		= 1;
   brickExplosionMaxVolume	= 20;
   brickExplosionMaxVolumeFloating	= 35;

   impactImpulse	= 400;
   verticalImpulse	= 400;
   explosion		= LightningExplosion;
   particleEmitter	= LightningTrailEmitter;

   muzzleVelocity	= 135;
   velInheritFactor	= 0;

   armingDelay		= 0;
   lifetime			= 4000;
   fadeDelay		= 4000;
   bounceElasticity	= 0.999;
   bounceFriction	= 0.001;
   isBallistic		= false;

   hasLight    = true;
   lightRadius = 5;
   lightColor  = "0 1 1";

   uiName = "Lightning Bolt"; //What you select it from a brick with
};

datablock ItemData(LightningItem)
{
	category	= "Weapon";
	className	= "Weapon";

	shapeFile	= "./3Dbolt.dts";
	rotate		= false;
	mass		= 0.2; //Very lightweight and bouncy
	density		= 0.1;
	elasticity	= 0.8;
	friction	= 0.2;
	emap		= true;

	uiName = "Lightning";
	iconName = "./Icon_Lightning";
	doColorShift = false; //The model has the following properties: Translucent, additive, self-illuminating

	image = LightningImage;
	canDrop = true;
};

datablock ShapeBaseImageData(LightningImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0; //Right hand
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = ("0 0 0");

   correctMuzzleVector = true;

   className = "WeaponImage";
   item = BowItem; //This doesn't do anything
   ammo = " ";
   projectile = LightningBolt;
   projectileType = Projectile;

   melee = false;
   armReady = true; //Raise your arm?
   
   lightType = "ConstantLight"; //This has never been done before
   lightColor = "0 1 1 1";
   LightTime = "1000";
   lightRadius = "4";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]				= LightningZapSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateSequence[1]				= "Ready";
	stateEmitter[1]					= LightningAmbientEmitter;
	stateEmitterTime[1]				= 600;

	stateName[2]					= "Fire";
	stateTransitionOnTimeout[2]		= "Reload";
	stateTimeoutValue[2]			= 1;
	stateFire[2]					= true;
	stateAllowImageChange[2]		= false;
	stateScript[2]					= "onFire"; //function activated at this point, see below
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= LightningFireSound;

	stateName[3]					= "Reload";
	stateSequence[3]				= "Reload";
	stateTransitionOnTriggerUp[3]	= "Ready";
	stateTransitionOnTriggerDown[3]	= "Fire";
	stateSequence[3]				= "Ready";
};

function LightningImage::onFire(%this,%obj,%slot) //Here's the function
{
	if(%obj.getDamagePercent() < 1.0) //If %obj, the person who fired it, is not dead
		%obj.playThread(2, shiftAway); //Play the animation for shift brick away to simulate recoil
	Parent::onFire(%this,%obj,%slot);
}
